Subject: RE: bug#6053: cp, ls, and mv bug: unknown error (252)

From: "Callahan, Patrick M." <[email-masked]>
Date: Tue, 8 Jun 2010 13:27:39 -0400

Bob,

Thanks for responding.  One thing I probably did not make clear is that I've tried 8.5 both depots and sources from the "HP Porting and Archive Centre" (http://hpux.connect.org.uk/). I realize that changes they make are out of your control however for a sysadmin like me they make my job easier in our heterogeneous environment.

I started to trace through the code and it seems that the problem is that getacl fails on our StorNext File System cvfs (aka snfs) does not support the getacl call.  I could easily accept better warnings when using cp or mv across file systems where acls are not supported on both but the problem is that we see the problems with other commands such as ls -l. Tusc output for an ls is attached and you can see that it is the getacl call that fails.

Patrick M. Callahan Senior Engineer
[email-masked]
General Dynamics Advanced Information Systems
10467 White Granite Drive Ste 304
Oakton VA 22124
work: 703.277.1471

-----Original Message-----
From: Bob Proulx [mailto:[email-masked]] 
Sent: Monday, June 07, 2010 8:10 PM
To: Callahan, Patrick M.; [email-masked]
Subject: Re: bug#6053: cp, ls, and mv bug: unknown error (252)

Pádraig Brady wrote:
> Callahan, Patrick M. wrote:
> > When using coreutils binaries either built from sources or installed
> > from the Porting And Archive Centre for HP-UX we see errors of the type
> > below when copying (cp), listing (ls), or moving (mv) files or
> > directories on Quantum's StorNext file system (cvfs).  When we build
> > "--without-acl" we do not see these errors.
> > 
> >> mv SEG_5_1* ~/release-input/dev-to-integration
> > mv: preserving permissions for
> > `/usr/people/archive/release-input/dev-to-integation/SEG_5_1.txt':
> > Unknown error (252)
> 
> It seems the file system is returning that which we're dutifully reporting.
> An strace or equivalent would be informative.
> Also the version of coreutils you're using would be good to note
> (8.5 was just released).

On HP-UX the tool 'tusc' (trace unix system call) is the equivalent
tool to 'strace'.  Using it you should be able to see the underlying
system calls and their status returns.  That would provide a valuable
clue as to where the problem lies.

You are using a combination of operating system and filesystem that
isn't very commonly seen.  Nor is it available to the developers
here.  You may very well have found a bug.  But is the bug in
coreutils mv or in the filesystem or in the kernel?  Any of those are
almost equally likely possibilites.  And not having such a system to
try it means that we will need to rely upon you to help.

Bob